<template>
  <div>
    <div class="titulo">
      <div class="ruta">
        <v-breadcrumbs :items="breadcrumbs">
          <template v-slot:divider>
            <v-icon>mdi-chevron-right</v-icon>
          </template>
        </v-breadcrumbs>
      </div>
      <strong>Disciplinas</strong>
    </div>
    <div class="pl-10 pr-10 contSecc">
      <strong
        class="text-h5 font-weight-black
      "
      >
        Disciplinas</strong
      >
      <p>
        Se muestran las disciplinas con su calificación final a nivel nacional.
      </p>
      <div class="titSec">
        <strong
          class="text-h6 font-weight-black
      "
        >
          Calificación final de la disciplina a nivel Negocio</strong
        >
      </div>
      <div class="gris">
        <v-row>
          <template v-for="(item, index) in disciplinas">
            <v-col
              :key="index"
              cols="12"
              md="6"
              lg="4"
              xl="4"
              class="pa-5 pl-10 pr-10"
            >
              <disciplina
                :semaforoUtils="semaforoUtils"
                v-bind="bindDisciplina(item)"
            /></v-col>
          </template>
        </v-row>
      </div>
    </div>
  </div>
</template>
<style scoped>
.gris {
  max-height: 800px;
  min-height: 800px;
  overflow: auto;
  padding: 100px;
}
</style>
<script>
import Disciplina from "@/views/secure/sistema-informacion/dashboards/v2/disciplinas/components/implementacion/NoXDisciplina.vue";
import store from "@/store";
const axios = store.state.axiosApiLocal;
const serviceCommons = store.state.serviceCommons;
export default {
  name: "Component-Disciplinas",
  components: {
    Disciplina,
  },
  data() {
    return {
      breadcrumbs: [
        {
          text: "Plataforma de Franquicia",
          disabled: false,
          exact: true,
          to: {
            name: "home",
          },
        },
        {
          text: "Sistema de Información",
          disabled: false,
          exact: true,
          to: {
            name: "sistema_informacion",
          },
        },
        {
          text: "Dashboard",
          disabled: false,
          exact: true,
          to: {
            name: "sistema_informacion_dashboard",
          },
        },
        {
          text: "Disciplinas",
          disabled: true,
          exact: true,
        },
      ],
      semaforo: null,
      semaforoUtils: null,
      disciplinas: [],
    };
  },
  methods: {
    bindDisciplina(disciplina) {
      return {
        loadingTitle: false,
        to: {
          name: "sistema_informacion_dashboard_v2_disciplinas_detalle",
          params: {
            disciplina: serviceCommons.objectToBase64(disciplina),
          },
        },
        data: disciplina,
      };
    },
    getSemaforoRangos(semaforo) {
      axios(
        "/sistema-informacion/tablero/semaforos/v1/" +
          semaforo.idSemaforo +
          "/rangos"
      )
        .then((response) => {
          let data = response.data;
          if (data) {
            semaforo.rangos = data.resultado.rangos;
            this.semaforoUtils = {
              getColor: this.getColorByValue,
            };
          }
        })
        .catch((error) => {
          semaforo.rangos = [];
        });
    },
    getSemaforo() {
      axios("/sistema-informacion/tablero/semaforos/v1/clave/semaforo-oficial")
        .then((response) => {
          let data = response.data;
          if (data) {
            this.semaforo = data.resultado;
            this.getSemaforoRangos(this.semaforo);
          }
        })
        .catch((error) => {
          if (error.response && error.response.status == 404) {
            this.semaforo = null;
          } else {
            console.log(error);
          }
        });
    },
    getColorByValue(value) {
      if (this.semaforo && this.semaforo.rangos) {
        let rango = this.semaforo.rangos.filter((item) => {
          if (value >= 100) {
            return item.limiteSuperior >= 100;
          } else {
            return item.limiteInferior <= value && item.limiteSuperior >= value;
          }
        });
        if (rango.length > 0) {
          return rango[0].color;
        }
      }
      return "grey";
    },
    getDisciplinas() {
      axios("/sistema-informacion/tablero/reportes/v1/disciplinas/busquedas")
        .then((response) => {
          let data = response.data;
          if (data) {
            this.disciplinas = data.resultado.disciplinas;
            this.disciplinas = this.disciplinas.map((disciplina) => {
              disciplina.isRedUnica = disciplina.idDisciplina == 31;
              return disciplina;
            });
          }
        })
        .catch((error) => {
          if (error.response && error.response.status == 404) {
            this.disciplinas = [];
          } else {
            console.log(error);
          }
        });
    },
  },
  created() {
    this.getSemaforo();
    this.getDisciplinas();
  },
};
</script>
